//
//  myScrollViewDome.m
//  myScrollViewDome
//
//  Created by Apple on 2019/9/2.
//  Copyright © 2019 Apple. All rights reserved.
//

#import "myScrollViewDome.h"

#define Screen_width [UIScreen mainScreen].bounds.size.width
#define Screen_height [UIScreen mainScreen].bounds.size.height

#define KF_width 30///间隔

@interface myScrollViewDome ()<UIScrollViewDelegate>
//记录当前页
@property(nonatomic,assign)int currentPage;
@property(nonatomic,strong)UIScrollView *scrollView;
@property(nonatomic,strong)NSTimer *timer;
@property(nonatomic,strong)UIPageControl *pageControl;

@end

@implementation myScrollViewDome

- (void)viewDidLoad {
    [super viewDidLoad];
    [self setScrollView];
}

#pragma mark - 设置一个scrollView
-(void)setScrollView{
    self.scrollView = [[UIScrollView alloc]init];
    
    NSLog(@"%f",self.scrollViewFrame.size.width);
    
    self.scrollView.frame = CGRectMake(0, 0, self.scrollViewFrame.size.width, self.scrollViewFrame.size.height);
    //    self.scrollView.backgroundColor = [UIColor greenColor];
    self.scrollView.contentSize = CGSizeMake(self.scrollViewFrame.size.width * (self.photoArray.count + 2), self.scrollViewFrame.size.height);
    
    //使用回调
    self.scrollView.delegate = self;
    
    NSMutableArray *mPhotoArray = [[NSMutableArray alloc]initWithArray:self.photoArray];
    
    //防止数组中没有图片
    if (mPhotoArray.count > 0) {
        //在头部插入最后一个图片
        [mPhotoArray insertObject:mPhotoArray.lastObject atIndex:0];
        //在尾部插入第一张图片
        [mPhotoArray addObject:mPhotoArray[1]];
    }
    
    //创建7张图片在scrollView中
    for (int i = 0; i < mPhotoArray.count; i++) {
        
        UIImageView *imageView = [[UIImageView alloc]init];
        imageView.frame = CGRectMake(i * self.scrollViewFrame.size.width, 0, self.scrollViewFrame.size.width, self.scrollViewFrame.size.height);
        [self.scrollView addSubview:imageView];
        
        
        UIImageView *imageViewsub = [[UIImageView alloc]init];
        imageViewsub.image = [UIImage imageNamed:mPhotoArray[i]];
        //        [imageViewsub sd_setImageWithURL:[NSURL URLWithString:mPhotoArray[i]]];
        imageViewsub.frame = CGRectMake(KF_width/2, KF_width/2, self.scrollViewFrame.size.width-KF_width, self.scrollViewFrame.size.height-KF_width);
        imageViewsub.contentMode=UIViewContentModeScaleAspectFill;
        [imageViewsub setClipsToBounds:YES];
        imageViewsub.tag = 1000+i;
        [imageView addSubview:imageViewsub];
        
        if (i==1) {
            
            imageViewsub.frame = CGRectMake(0, 0, self.scrollViewFrame.size.width, self.scrollViewFrame.size.height);
        }
        
        imageView.userInteractionEnabled = YES;
        imageViewsub.userInteractionEnabled = YES;
        UITapGestureRecognizer *tap = [[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(TapClick:)];
        [imageViewsub addGestureRecognizer:tap];
    }
    
    ///是否分页
    self.scrollView.pagingEnabled = YES;
    
    ////个属性是父视图是否遮盖子视图, NO代表不遮盖
    self.scrollView.clipsToBounds = NO;
    
    //设置显示第一张的scrollView位置
    self.scrollView.contentOffset = CGPointMake(self.scrollViewFrame.size.width, 0);
    
    self.currentPage = 1;
    
    [self.view addSubview:self.scrollView];
    
    //做一个计时器去改变scrollView
    self.timer = [NSTimer scheduledTimerWithTimeInterval:2 target:self selector:@selector(timerChange) userInfo:nil repeats:YES];
    
    //制作一个pageControl
    self.pageControl = [[UIPageControl alloc]init];
    self.pageControl.numberOfPages = self.photoArray.count;
    
    self.pageControl.currentPage = self.currentPage - 1;
    
    self.pageControl.frame = CGRectMake(self.scrollViewFrame.size.width/2 - 200/2 , self.scrollViewFrame.size.height - 20 , 200, 20);
    _pageControl.pageIndicatorTintColor = [UIColor whiteColor];
    _pageControl.currentPageIndicatorTintColor = [UIColor grayColor];
    
    [self.view addSubview:self.pageControl];
    
}

-(void)TapClick:(UITapGestureRecognizer *)tap{
    
        UIImageView *img = (UIImageView *)tap.view;
        [self.delegate ScrollViewImageClickWith:(int)img.tag-1000];
}

////======================================================

//改变scrollView的位置
-(void)changeScrollContentOffSet{
    
    if (self.currentPage == 0) {
        self.scrollView.contentOffset = CGPointMake(self.scrollViewFrame.size.width * self.photoArray.count, 0);
        self.currentPage = self.scrollView.contentOffset.x/self.scrollViewFrame.size.width;
        
        self.pageControl.currentPage = self.currentPage - 1;
    }
    else if(self.currentPage == (self.photoArray.count + 1)){
        self.scrollView.contentOffset = CGPointMake(self.scrollViewFrame.size.width * 1, 0);
        
        self.currentPage = self.scrollView.contentOffset.x/self.scrollViewFrame.size.width;
        
        self.pageControl.currentPage = self.currentPage - 1;
    }
    
    [self setBigCenter];
}

//中间图片凸起放大
-(void)setBigCenter{
    
    for(int i = 0; i < self.photoArray.count+2; i++){
        
        UIImageView *imageViewsub = (UIImageView *)[self.view viewWithTag:1000+i];
        imageViewsub.frame = CGRectMake(KF_width/2, KF_width/2, self.scrollViewFrame.size.width-KF_width, self.scrollViewFrame.size.height-KF_width);
        
        if (i==self.currentPage) {
            
            [UIView animateWithDuration:0.2 animations:^{
                
                imageViewsub.frame = CGRectMake(0, 0, self.scrollViewFrame.size.width, self.scrollViewFrame.size.height);
                
            }];
        }
    }
    
}

-(void)timerChange{
    //每隔一定时间加滚动一页
    [self.scrollView scrollRectToVisible:CGRectMake(self.scrollView.contentOffset.x + self.scrollViewFrame.size.width, 0, self.scrollViewFrame.size.width, self.scrollViewFrame.size.height) animated:YES];
}

#pragma mark - scrollViewDelegate
-(void)scrollViewDidEndDecelerating:(UIScrollView *)scrollView{
    
    self.currentPage = scrollView.contentOffset.x/self.scrollViewFrame.size.width;
    
    self.pageControl.currentPage = self.currentPage - 1;
    
    [self changeScrollContentOffSet];
    
    if (self.timer == nil) {
        //做一个计时器去改变scrollView
        self.timer = [NSTimer scheduledTimerWithTimeInterval:2 target:self selector:@selector(timerChange) userInfo:nil repeats:YES];
    }
}

-(void)scrollViewDidEndScrollingAnimation:(UIScrollView *)scrollView{
    //在滚动完以后设置页码
    self.currentPage = self.scrollView.contentOffset.x/self.scrollViewFrame.size.width;
    self.pageControl.currentPage = self.currentPage - 1;
    [self changeScrollContentOffSet];
}

-(void)scrollViewWillBeginDragging:(UIScrollView *)scrollView{
    [self.timer invalidate];
    self.timer = nil;
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
